diff --git a/include/helper/odp_linux.h b/include/helper/odp_linux.h
index 3e91ce0..3076c22 100644
--- a/include/helper/odp_linux.h
+++ b/include/helper/odp_linux.h
@@ -66,10 +66,3 @@ void odp_linux_pthread_join(odp_linux_pthread_t *thread_tbl, int num);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/helper/odp_ring.h b/include/helper/odp_ring.h
index ed58e91..0911531 100644
--- a/include/helper/odp_ring.h
+++ b/include/helper/odp_ring.h
@@ -192,7 +192,7 @@ typedef struct odp_ring {
  *    - ENOMEM - no appropriate memory area found in which to create memzone
  */
 odp_ring_t *odp_ring_create(const char *name, unsigned count,
-						unsigned flags);
+			    unsigned flags);
 
 
 /**
@@ -245,7 +245,7 @@ void odp_ring_dump(const odp_ring_t *r);
  *   - n: Actual number of objects enqueued.
  */
 int __odp_ring_mp_do_enqueue(odp_ring_t *r, void * const *obj_table,
-			 unsigned n, enum odp_ring_queue_behavior behavior);
+			     unsigned n, enum odp_ring_queue_behavior behavior);
 
 /**
  * Enqueue several objects on a ring (NOT multi-producers safe).
@@ -300,7 +300,7 @@ int __odp_ring_sp_do_enqueue(odp_ring_t *r, void * const *obj_table,
  */
 
 int __odp_ring_mc_do_dequeue(odp_ring_t *r, void **obj_table,
-			 unsigned n, enum odp_ring_queue_behavior behavior);
+			     unsigned n, enum odp_ring_queue_behavior behavior);
 
 /**
  * Dequeue several objects from a ring (NOT multi-consumers safe).
@@ -347,7 +347,7 @@ int __odp_ring_sc_do_dequeue(odp_ring_t *r, void **obj_table,
  *   - -ENOBUFS: Not enough room in the ring to enqueue, no object is enqueued.
  */
 int odp_ring_mp_enqueue_bulk(odp_ring_t *r, void * const *obj_table,
-				unsigned n);
+			     unsigned n);
 
 /**
  * Enqueue several objects on a ring (NOT multi-producers safe).
diff --git a/include/odp_align.h b/include/odp_align.h
index ce72f01..83495a8 100644
--- a/include/odp_align.h
+++ b/include/odp_align.h
@@ -180,10 +180,3 @@ extern "C" {
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_atomic.h b/include/odp_atomic.h
index 630b8bc..5a25dc7 100644
--- a/include/odp_atomic.h
+++ b/include/odp_atomic.h
@@ -360,7 +360,7 @@ static inline uint64_t odp_atomic_fetch_add_u64(odp_atomic_u64_t *ptr,
 						uint64_t value)
 {
 	return __sync_fetch_and_add((odp_atomic_u32_t *)ptr,
-				   (uint32_t)value);
+				    (uint32_t)value);
 }
 #else
 static inline uint64_t odp_atomic_fetch_add_u64(odp_atomic_u64_t *ptr,
@@ -394,7 +394,7 @@ static inline uint64_t odp_atomic_fetch_sub_u64(odp_atomic_u64_t *ptr,
 						uint64_t value)
 {
 	return __sync_fetch_and_sub((odp_atomic_u32_t *)ptr,
-				   (uint32_t)value);
+				    (uint32_t)value);
 }
 #else
 static inline uint64_t odp_atomic_fetch_sub_u64(odp_atomic_u64_t *ptr,
@@ -468,4 +468,3 @@ odp_atomic_cmpset_u64(odp_atomic_u64_t *dst, uint64_t exp, uint64_t src)
 #endif
 
 #endif
-
diff --git a/include/odp_barrier.h b/include/odp_barrier.h
index 4547a26..a7b3215 100644
--- a/include/odp_barrier.h
+++ b/include/odp_barrier.h
@@ -54,10 +54,3 @@ void odp_barrier_sync(odp_barrier_t *barrier);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_buffer.h b/include/odp_buffer.h
index 2d2c25a..d79e76d 100644
--- a/include/odp_buffer.h
+++ b/include/odp_buffer.h
@@ -98,10 +98,3 @@ void odp_buffer_print(odp_buffer_t buf);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_buffer_pool.h b/include/odp_buffer_pool.h
index 8ac744a..9112489 100644
--- a/include/odp_buffer_pool.h
+++ b/include/odp_buffer_pool.h
@@ -97,10 +97,3 @@ void odp_buffer_free(odp_buffer_t buf);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_config.h b/include/odp_config.h
index 1b0b76e..7a15ff9 100644
--- a/include/odp_config.h
+++ b/include/odp_config.h
@@ -49,10 +49,3 @@ extern "C" {
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_coremask.h b/include/odp_coremask.h
index 163de22..141cb6a 100644
--- a/include/odp_coremask.h
+++ b/include/odp_coremask.h
@@ -130,7 +130,7 @@ int odp_coremask_count(const odp_coremask_t *mask);
  * @param src2    Source mask 2
  */
 static inline void odp_coremask_and(odp_coremask_t *dest, odp_coremask_t *src1,
-						odp_coremask_t *src2)
+				    odp_coremask_t *src2)
 {
 	dest->_u64[0] = src1->_u64[0] & src2->_u64[0];
 }
@@ -143,7 +143,7 @@ static inline void odp_coremask_and(odp_coremask_t *dest, odp_coremask_t *src1,
  * @param src2    Source mask 2
  */
 static inline void odp_coremask_or(odp_coremask_t *dest, odp_coremask_t *src1,
-					odp_coremask_t *src2)
+				   odp_coremask_t *src2)
 {
 	dest->_u64[0] = src1->_u64[0] | src2->_u64[0];
 }
@@ -156,7 +156,7 @@ static inline void odp_coremask_or(odp_coremask_t *dest, odp_coremask_t *src1,
  * @param src2    Source mask 2
  */
 static inline void odp_coremask_xor(odp_coremask_t *dest, odp_coremask_t *src1,
-					odp_coremask_t *src2)
+				    odp_coremask_t *src2)
 {
 	dest->_u64[0] = src1->_u64[0] ^ src2->_u64[0];
 }
@@ -165,7 +165,7 @@ static inline void odp_coremask_xor(odp_coremask_t *dest, odp_coremask_t *src1,
  * Test if two masks contain the same cores
  */
 static inline int odp_coremask_equal(odp_coremask_t *mask1,
-					odp_coremask_t *mask2)
+				     odp_coremask_t *mask2)
 {
 	return (mask1->_u64[0] == mask2->_u64[0]);
 }
diff --git a/include/odp_hints.h b/include/odp_hints.h
index ce74e76..e1cd1d0 100644
--- a/include/odp_hints.h
+++ b/include/odp_hints.h
@@ -80,10 +80,3 @@ extern "C" {
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_init.h b/include/odp_init.h
index d04f349..490324a 100644
--- a/include/odp_init.h
+++ b/include/odp_init.h
@@ -53,10 +53,3 @@ int odp_init_local(int thr_id);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_packet.h b/include/odp_packet.h
index 4a16e11..f7014fb 100644
--- a/include/odp_packet.h
+++ b/include/odp_packet.h
@@ -225,10 +225,3 @@ int odp_packet_copy(odp_packet_t pkt_dst, odp_packet_t pkt_src);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_packet_io.h b/include/odp_packet_io.h
index 0002b1e..cfefac0 100644
--- a/include/odp_packet_io.h
+++ b/include/odp_packet_io.h
@@ -134,4 +134,3 @@ odp_pktio_t odp_pktio_get_input(odp_packet_t pkt);
 #endif
 
 #endif
-
diff --git a/include/odp_queue.h b/include/odp_queue.h
index 6401aea..71499d8 100644
--- a/include/odp_queue.h
+++ b/include/odp_queue.h
@@ -193,10 +193,3 @@ odp_schedule_sync_t odp_queue_sched_type(odp_queue_t queue);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_shared_memory.h b/include/odp_shared_memory.h
index 28b650d..8ac8847 100644
--- a/include/odp_shared_memory.h
+++ b/include/odp_shared_memory.h
@@ -57,5 +57,3 @@ void odp_shm_print_all(void);
 #endif
 
 #endif
-
-
diff --git a/include/odp_spinlock.h b/include/odp_spinlock.h
index f25d068..52b7a71 100644
--- a/include/odp_spinlock.h
+++ b/include/odp_spinlock.h
@@ -81,10 +81,3 @@ int odp_spinlock_is_locked(odp_spinlock_t *spinlock);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_std_types.h b/include/odp_std_types.h
index 7013ca3..b12a2f3 100644
--- a/include/odp_std_types.h
+++ b/include/odp_std_types.h
@@ -36,6 +36,3 @@ extern "C" {
 #endif
 
 #endif
-
-
-
diff --git a/include/odp_sync.h b/include/odp_sync.h
index cf56faa..c106c75 100644
--- a/include/odp_sync.h
+++ b/include/odp_sync.h
@@ -50,10 +50,3 @@ static inline void odp_sync_stores(void)
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_system_info.h b/include/odp_system_info.h
index 50b5081..7a02df7 100644
--- a/include/odp_system_info.h
+++ b/include/odp_system_info.h
@@ -70,10 +70,3 @@ int odp_sys_core_count(void);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_thread.h b/include/odp_thread.h
index 31057f7..e8e8c8a 100644
--- a/include/odp_thread.h
+++ b/include/odp_thread.h
@@ -53,10 +53,3 @@ int odp_thread_core(void);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/include/odp_time.h b/include/odp_time.h
index d552222..188d1fe 100644
--- a/include/odp_time.h
+++ b/include/odp_time.h
@@ -65,5 +65,3 @@ uint64_t odp_time_ns_to_cycles(uint64_t ns);
 #endif
 
 #endif
-
-
diff --git a/include/odp_version.h b/include/odp_version.h
index 152b329..c823e2d 100644
--- a/include/odp_version.h
+++ b/include/odp_version.h
@@ -74,10 +74,3 @@ static inline const char *odp_version_api_str(void)
 #endif
 
 #endif
-
-
-
-
-
-
-